<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Exception StructType
 * @subpackage Structs
 */
class Exception extends AbstractStructBase
{
    /**
     * The Exception
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var mixed
     */
    public $Exception;
    /**
     * Constructor method for Exception
     * @uses Exception::setException()
     * @param mixed $exception
     */
    public function __construct($exception = null)
    {
        $this
            ->setException($exception);
    }
    /**
     * Get Exception value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return mixed|null
     */
    public function getException()
    {
        return isset($this->Exception) ? $this->Exception : null;
    }
    /**
     * Set Exception value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param mixed $exception
     * @return \StructType\Exception
     */
    public function setException($exception = null)
    {
        if (is_null($exception) || (is_array($exception) && empty($exception))) {
            unset($this->Exception);
        } else {
            $this->Exception = $exception;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Exception
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
